import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import javax.swing.JPasswordField;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;

import SecureBlackbox.Base.TElX509Certificate;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class ProtHandlerPropsDialog extends JDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbSourceFile;
	private JTextField tbObjName;
	private JTextField tbCert;
	private JPasswordField tbCertPass;
	private JCheckBox cbProtect;
	private JComboBox<String> cbIntegrityProt;
	private boolean isOk;
	private JLabel label3;
	private JLabel label4;
	private JLabel label5;
	private JButton btnBrowseCert;
	private TElX509Certificate m_Cert;
	private int m_IntegrityProtection;
	protected boolean m_Protect;
	protected String m_SourceFile;
	protected String m_ObjectName;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			ProtHandlerPropsDialog dialog = new ProtHandlerPropsDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public ProtHandlerPropsDialog() {
		setTitle("Object protection settings");
		setBounds(100, 100, 450, 338);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblSourceFile = new JLabel("Source file:");
			lblSourceFile.setBounds(10, 11, 141, 14);
			contentPanel.add(lblSourceFile);
		}
		{
			tbSourceFile = new JTextField();
			tbSourceFile.setBounds(10, 26, 321, 20);
			contentPanel.add(tbSourceFile);
			tbSourceFile.setColumns(10);
		}
		{
			JButton btnBrowse = new JButton("Browse");
			btnBrowse.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					tbSourceFile.setText(getFileName());
				}
			});			
			btnBrowse.setBounds(341, 25, 91, 23);
			contentPanel.add(btnBrowse);
		}
		{
			JLabel lblObjectName = new JLabel("Object name:");
			lblObjectName.setBounds(10, 57, 106, 14);
			contentPanel.add(lblObjectName);
		}
		{
			tbObjName = new JTextField();
			tbObjName.setBounds(10, 73, 237, 20);
			contentPanel.add(tbObjName);
			tbObjName.setColumns(10);
		}
		
		cbProtect = new JCheckBox("Protect this object");
		cbProtect.setBounds(10, 100, 156, 23);
		cbProtect.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {
				SwitchProtectionControls(cbProtect.isSelected());
			}
		});
		contentPanel.add(cbProtect);
		
		label3 = new JLabel("Use the following certificate:");
		label3.setBounds(20, 132, 227, 14);
		contentPanel.add(label3);
		
		tbCert = new JTextField();
		tbCert.setBounds(20, 149, 311, 20);
		contentPanel.add(tbCert);
		tbCert.setColumns(10);
		
		btnBrowseCert = new JButton("Browse");
		btnBrowseCert.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbCert.setText(getFileName());
			}
		});		
		btnBrowseCert.setBounds(341, 148, 91, 23);
		contentPanel.add(btnBrowseCert);
		
		label4 = new JLabel("Certificate password (if needed):");
		label4.setBounds(20, 174, 211, 14);
		contentPanel.add(label4);
		
		tbCertPass = new JPasswordField();
		tbCertPass.setBounds(20, 191, 200, 20);
		contentPanel.add(tbCertPass);
		
		label5 = new JLabel("Integrity protection:");
		label5.setBounds(20, 216, 200, 14);
		contentPanel.add(label5);
		
		m_Cert = new TElX509Certificate();
		cbIntegrityProt = new JComboBox<String>();
		cbIntegrityProt.setModel(new DefaultComboBoxModel<String>(new String[] {"No protection", "Basic protection (whole object only)", "Extended protection (block-based data integrity protection)"}));
		cbIntegrityProt.setBounds(20, 233, 200, 22);
		contentPanel.add(cbIntegrityProt);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
			            if (cbProtect.isSelected())
			            {
			                int r = m_Cert.loadFromFileAuto(tbCert.getText(), new String(tbCertPass.getPassword()));
			                if (r != 0)
			                {
			                    showErrorMessage("Failed to load certificate, error " + r);
			                    return;
			                }
			                m_Protect = true;
			            }
			            else
			            {
			                m_Protect = false;
			            }
			            m_IntegrityProtection = cbIntegrityProt.getSelectedIndex();
			            m_SourceFile = tbSourceFile.getText();
			            m_ObjectName = tbObjName.getText();
						
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});				
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	protected String getFileName() {
		JFileChooser fc = new JFileChooser();
		
		int returnVal = fc.showOpenDialog(this);

        if (returnVal == JFileChooser.APPROVE_OPTION)
            return fc.getSelectedFile().getAbsolutePath();
        
        return "";
	}
	
	public void showErrorMessage(String msg) {
		JOptionPane.showMessageDialog(null, msg, "Error", JOptionPane.ERROR_MESSAGE);
	}

	public void Init() {
        cbProtect.setSelected(false);
        SwitchProtectionControls(false);
        cbIntegrityProt.setSelectedIndex(0);
	}

    private void SwitchProtectionControls(boolean value)
    {
        tbCert.setEnabled(value);
        tbCertPass.setEnabled(value);
        label3.setEnabled(value);
        label4.setEnabled(value);
        btnBrowseCert.setEnabled(value);
        label5.setEnabled(value);
        cbIntegrityProt.setEnabled(value);
   }
	
	public boolean isOK() {
		return isOk;
	}

	public boolean getProtect() {
		return cbProtect.isSelected();
	}

	public TElX509Certificate getCert() {
		return m_Cert;
	}

	public String getSourceFile() {
		return m_SourceFile;
	}

	public String getObjectName() {
		return m_ObjectName;
	}

	public int getIntegrityProtection() {
		return m_IntegrityProtection;
	}
}
