import java.util.Vector;

import javax.swing.table.AbstractTableModel;

import SecureBlackbox.Cloud.*;

public class ObjectsTableModel extends AbstractTableModel {
	private static final long serialVersionUID = 2771284071470299948L;
	public static final int NAME_INDEX = 0;
	public static final int SIZE_INDEX = 1;
	public static final int PROT_INDEX = 2;
	
	protected Vector<ObjectsDataRow> dataVector = new Vector<ObjectsDataRow>();
	
    protected String[] columnNames = {
    		"Name",
    		"Size", 
    		"Protected" 
    };
        
	public String getColumnName(int column) {
        return columnNames[column];
    }
    
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

    public Object getValueAt(int row, int col) {
        ObjectsDataRow record = (ObjectsDataRow)dataVector.get(row);
        switch (col) {
        	case NAME_INDEX:
        		return record.Name;
        	case SIZE_INDEX:
	        	 return record.Size;
            case PROT_INDEX:
               return record.Protected;
            default:
               return new Object();
        }
    }

	public void clear() {
		dataVector.removeAllElements();
		fireTableDataChanged();
	}

	public TElFileDataStorageObject getTag(int row) {
		return dataVector.get(row).Tag;
	}

	public void addItem(TElCustomDataStorageObject item) {
		TElFileDataStorageObject tag = (TElFileDataStorageObject)item;
		
		String name = item.getName();
		String size = tag .getSize() + "";
		String prot = item.getSecured() ? "yes" : "no";
		
		dataVector.addElement(new ObjectsDataRow(name, size, prot, tag));
		fireTableDataChanged();		
	}
}