import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.event.TreeExpansionEvent;

import org.freepascal.rtl.TObject;

import SecureBlackbox.SMIME.*;
import SecureBlackbox.PGP.TElPGPCustomSecretKey;
import SecureBlackbox.PGP.TSBPGPKeyPassphraseEvent;
import SecureBlackbox.PGPMIME.*;
import SecureBlackbox.Base.*;
import SecureBlackbox.MIME.SBMIME;
import SecureBlackbox.MIME.*;

public class BeforeExpandHandler
{
	 TreeExpansionEvent e;
	 
	 boolean bAllowExpansion = true;
	 TreeNodeInfo NodeInfo, NodeInfoChild, NewNode, NullNode, tmpNode;
	 ElMessageDemo md;
	 TElMessagePart mp, mpi;
	 TElMailAddress ma;
	 TElMessageHeaderField f;
	 String S;
	 int i, iCount, k, g, ig;
	
	 TElMailAddressList al;
	 TElMailAddressGroup ag;

	 void addPartHandlerOnly(TElMessagePart mp)
	 {
	   if ( (mp != null) && (mp.getMessagePartHandler() != null) ) {
	     NewNode = new TreeNodeInfo(TagInfo.tiPartHandler, mp);
	     NewNode.setText("Part Handler: \"" + mp.getMessagePartHandler().getPartHandlerDescription() + "\"");
	     NodeInfo.add(NewNode);
	     if ( ! mp.getIsActivatedMessagePartHandler() ) {
	       if ( mp.getMessagePartHandler().getIsError() ) {
	         NullNode = new TreeNodeInfo(TagInfo.tiError, null);
	         NullNode.setText("ERROR: " + mp.getMessagePartHandler().getErrorText());
	         NewNode.add(NullNode);
	       }
	       else
	       {
	         try
	         {
				  if (mp.getMessagePartHandler() instanceof TElMessagePartHandlerSMime)
				  {
					  MimeViewer_OptionsSMime.SMIMECollectCertificates();
					  ((TElMessagePartHandlerSMime)mp.getMessagePartHandler()).setCertificatesStorage(MimeViewer_OptionsSMime.CurCertStorage); 
				  }
	
				  if (mp.getMessagePartHandler() instanceof TElMessagePartHandlerPGPMime)
				  {
					  TElMessagePartHandlerPGPMime HandlerPGPMIME = (TElMessagePartHandlerPGPMime)mp.getMessagePartHandler();
					  HandlerPGPMIME.setDecryptingKeys(MimeViewer_OptionsPGPMime.Keyring);
					  HandlerPGPMIME.setVerifyingKeys(MimeViewer_OptionsPGPMime.Keyring);
					  HandlerPGPMIME.setOnKeyPassphrase(new TSBPGPKeyPassphraseEvent(PGPMIMEKeyPassphrase));
				  }
	
	           try
	           {
	             mp.getMessagePartHandler().decode(false);
	           }
	           finally
	           {
	           }
	           if ( mp.getMessagePartHandler().getIsError() ) {
	             NullNode = new TreeNodeInfo(TagInfo.tiError, null);
	             NullNode.setText("ERROR: " + mp.getMessagePartHandler().getErrorText());
	             NewNode.add(NullNode);
	           }
	           else
	           {
	             if ( mp.getMessagePartHandler().getDecodedPart() != null ) {
	               NullNode = new TreeNodeInfo(TagInfo.tiNull, null);
	               NullNode.setText("...");
	               NewNode.add(NullNode);
	             }
	             if ( mp.getMessagePartHandler().getResultCode() == SBMIME.EL_WARNING ) {
	               if ( mp.getMessagePartHandler().getErrorText().length() > 0 )
	                 S = mp.getMessagePartHandler().getErrorText();
	               else
	                 S = "Some warning was issued when handling this message part";
	               NullNode = new TreeNodeInfo(TagInfo.tiWarning, null);
	               NullNode.setText("WARNING: " + S);
	               NewNode.add(NullNode);
	             };
	           }
	         }
	         catch (Exception e)
	         {
	           NullNode = new TreeNodeInfo(TagInfo.tiError, null);
	           NullNode.setText("ERROR: " + e.getMessage());
	           NewNode.add(NullNode);
	         }
	       }
	     }
	   }
	 }
	
	  TSBPGPKeyPassphraseEvent.Callback PGPMIMEKeyPassphrase = new TSBPGPKeyPassphraseEvent.Callback() {
			
		public void tsbpgpKeyPassphraseEventCallback(TObject sender,
				TElPGPCustomSecretKey key, TSBString pass, TSBBoolean cancel) {
			String p = requestKeyPassphrase(key);
			if (p.length() == 0) {
			  cancel.value = true;
			} else {
			
			pass.value = p;
			cancel.value = false;
			}
		}
	};
	
	private String requestKeyPassphrase(TElPGPCustomSecretKey key) {
		JPasswordField jpf = new JPasswordField();
		int result = JOptionPane.showConfirmDialog(null, jpf, "Passphrase is needed for secret key", JOptionPane.OK_CANCEL_OPTION);
		if (result == 0)
			return new String(jpf.getPassword());
		return "";
	}

	
	 void addBodyPartHandlerOnly(TElMessagePart mp)
	 {
	   if ( (mp != null) && (mp.getMessageBodyPartHandler() != null) ) {
	     NewNode = new TreeNodeInfo(TagInfo.tiPartBodyHandler, mp);
	     NewNode.setText("Body Handler: \"" + mp.getMessageBodyPartHandler().getPartHandlerDescription() + "\"");
	     NodeInfo.add(NewNode);
	     if ( mp.getMessageBodyPartHandler().getIsError() ) {
	       NullNode = new TreeNodeInfo(TagInfo.tiError, null);
	       NullNode.setText("ERROR: " + mp.getMessageBodyPartHandler().getErrorText());
	       NewNode.add(NullNode);
	     }
	     else
	     {
	       if (mp.getMessageBodyPartHandler().getDecodedPart() != null) {
	         NullNode = new TreeNodeInfo(TagInfo.tiNull, null);
	         NullNode.setText("...");
	         NewNode.add(NullNode);
	       }
	       if ( mp.getMessageBodyPartHandler().getResultCode() == SBMIME.EL_WARNING ) {
	         if ( mp.getMessageBodyPartHandler().getErrorText().length() > 0 )
	           S = mp.getMessageBodyPartHandler().getErrorText();
	         else
	           S = "Some warning was issued when handling body of this message part";;
	         NullNode = new TreeNodeInfo(TagInfo.tiWarning, null);
	         NullNode.setText("WARNING: " + S);
	         NewNode.add(NullNode);
	       }
	     }
	   }
	 }
	
	 void addHeadersInfoForMessagePart(TElMessagePart mp)
	 {
	   if ( (mp != null) && ProjectOptions.fHeaderInTree && (
	     (mp.getHeader().getFieldsCount() > 0) || (mp.getHeader().getMailAddressListCount()>0) ) )
	   {
	     NewNode = new TreeNodeInfo(TagInfo.tiHeaders, mp);
	     NewNode.setText("Headers");
	     NodeInfo.add(NewNode);
	     if ( ProjectOptions.fFieldsInTree ) {
	       NullNode = new TreeNodeInfo(TagInfo.tiNull, null);
	       NullNode.setText("...");
	       NewNode.add(NullNode);
	     }
	   }
	 }
	
	 void addBodyInfoForMessagePart(TElMessagePart mp)
	 {
	   if ( (mp != null) && ( ProjectOptions.fBodyInTree || mp.isMultipart() ) ) {
	     NewNode = new TreeNodeInfo(TagInfo.tiBody, mp);
	     NewNode.setText("Body");
	     NodeInfo.add(NewNode);
	     if ( mp.isMultipart() && (mp.getPartsCount()>0) ) {
	       NullNode = new TreeNodeInfo(TagInfo.tiNull, null);
	       NullNode.setText("...");
	       NewNode.add(NullNode);
	     }
	     else
	     {
	       S = mp.getContentType();
	       if ( S.length() > 0 )
	         NewNode.setText(NewNode.getText() + " : [ " + S + "/" + mp.getContentSubtype() + " ]");
	       if ( mp.isMessage() ) {
	         NullNode = new TreeNodeInfo(TagInfo.tiNull, null);
	         NullNode.setText("...");
	         NewNode.add(NullNode);
	       }
	     }
	   }
	 }
	
	 public void addMessageInfoForMessagePart(TElMessagePart mp)
	 {
	   if (mp != null) {
	     // HEADERS
	     addHeadersInfoForMessagePart(mp);
	     // BODY
	     if ( ! ( (mp != null) && (mp.getMessageBodyPartHandler() != null) ) )
	       addBodyInfoForMessagePart(mp);
	     // PART HANDLER
	     addPartHandlerOnly(mp);
	     // PART BODY HANDLER
	     addBodyPartHandlerOnly(mp);
	   }
	 }
	
	 void addPartInfoForMessagePart(TElMessagePart mp, int partIndex)
	 {
	   if (mp != null) {
	     TagInfo ti = TagInfo.tiPart;
	     // PART
	     S = "Part";
	     if ( mp.isMultipart() )
	       ti = TagInfo.tiPartList;
	     if ( partIndex >= 0 )
	       S += " [ " + partIndex + " ]";
	     if ( mp.isMultipart() )
	       S += " / [" + mp.getContentType() + "/" + mp.getContentSubtype() + "]";
	     else
	     if ( ! mp.isMultipart() ){
	       String sFile = mp.getFileName().trim();
	       if ( sFile.length() > 0 )
	         S += ": \"" + sFile + "\"";
	     }
	     NewNode = new TreeNodeInfo(ti, mp);
	     NewNode.setText(S);
	     NodeInfo.add(NewNode);
	     NullNode = new TreeNodeInfo(TagInfo.tiNull, null);
	     NullNode.setText("...");
	     NewNode.add(NullNode);
	   }
	 }
	
	 void addPartListInfoForMessagePart(TElMessagePart mp, int partIndex)
	 {
	   if (mp != null) {
	     // HEADERS
	     addHeadersInfoForMessagePart(mp);
	     // BODY
	     if ( ! ( (mp != null) && (mp.getMessageBodyPartHandler() != null) ) )
	       addBodyInfoForMessagePart(mp);
	     // PART HANDLER
	     addPartHandlerOnly(mp);
	     // PART BODY HANDLER
	     addBodyPartHandlerOnly(mp);
	   }
	 }
	
	 void addAtachedMessage(TElMessagePart mp) throws Exception
	 {
	   TSBInteger bufferSize = new TSBInteger();
	   mp.getDataSize(bufferSize);
	   TByteArrayConst buffer = new TByteArrayConst();
	   mp.getData(buffer, bufferSize);
	   NodeInfo.remove(NodeInfoChild); // !!!
	   NodeInfoChild = null;
	   TAnsiStringMIMEStream sm = new TAnsiStringMIMEStream();
	   sm.setMemory(buffer.Data, buffer.Data.length);
	   new ElMimeParserTask(NodeInfo, "", sm);
	 }
}
