import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.border.TitledBorder;
import javax.swing.JCheckBox;
import javax.swing.JTextField;

import SecureBlackbox.Base.TElX509Certificate;
import SecureBlackbox.Office.TElOfficeBinaryCryptoAPISignatureHandler;
import SecureBlackbox.Office.TElOfficeBinaryXMLSignatureHandler;
import SecureBlackbox.Office.TElOfficeDocument;
import SecureBlackbox.Office.TElOfficeOpenXMLSignatureHandler;
import SecureBlackbox.Office.TElOfficeOpenXMLSignatureLine;
import SecureBlackbox.Office.TElOfficeOpenXPSSignatureDefinition;
import SecureBlackbox.Office.TElOfficeOpenXPSSignatureHandler;
import SecureBlackbox.Office.TElOfficeXMLSignatureInfoV1;
import SecureBlackbox.Office.TElOpenOfficeSignatureHandler;
import SecureBlackbox.Office.TSBOfficeDocumentFormat;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import java.util.Date;


public class SignatureOptionsForm extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbSigText;
	private JTextField tbSigComments;
	private JComboBox<String> cmbSignatureType;
	private JComboBox<String> cmbSignatureView;
	private JCheckBox cbIncludeSigInfo;
	private JCheckBox cbSignDocument;
	private JCheckBox cbSignSignatureOrigin;
	private JCheckBox cbSignCoreProperties;

    TElX509Certificate _Certificate = null;
    TElOfficeDocument _OfficeDocument = null;
    private JButton btnSign;
    private JButton btnAddSigView;
    private JPanel gbSignatureInfo;
    private JLabel lbViewInfo;
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			SignatureOptionsForm dialog = new SignatureOptionsForm();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public SignatureOptionsForm() {
		setTitle("Signature Options");
		setBounds(100, 100, 399, 499);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JButton btnSelectCertificate = new JButton("Select Certificate");
			btnSelectCertificate.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					selectCertificateClick();
				}
			});
			btnSelectCertificate.setBounds(10, 11, 146, 23);
			contentPanel.add(btnSelectCertificate);
		}
		{
			JLabel lblSignatureType = new JLabel("Signature Type");
			lblSignatureType.setBounds(20, 45, 146, 14);
			contentPanel.add(lblSignatureType);
		}
		{
			cmbSignatureType = new JComboBox<String>();
			cmbSignatureType.addItemListener(new ItemListener() {
				public void itemStateChanged(ItemEvent e) {
					cmbSignatureType_SelectedIndexChanged(e);
				}
			});
			cmbSignatureType.setModel(new DefaultComboBoxModel<String>(new String[] {"RC4/40 bits", "RC4 CryptoAPI"}));
			cmbSignatureType.setBounds(176, 41, 205, 22);
			contentPanel.add(cmbSignatureType);
		}
		{
			JPanel panel = new JPanel();
			panel.setBorder(new TitledBorder(null, "Signature Line/Definition", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			panel.setBounds(10, 86, 371, 130);
			contentPanel.add(panel);
			panel.setLayout(null);
			{
				cmbSignatureView = new JComboBox<String>();
				cmbSignatureView.addItemListener(new ItemListener() {
					public void itemStateChanged(ItemEvent e) {
						cmbSignatureView_SelectedIndexChanged(e);
					}
				});
				cmbSignatureView.setModel(new DefaultComboBoxModel<String>(new String[] {"RC4/40 bits", "RC4 CryptoAPI"}));
				cmbSignatureView.setBounds(10, 22, 351, 22);
				panel.add(cmbSignatureView);
			}
			{
				btnAddSigView = new JButton("Add");
				btnAddSigView.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						addSigView();
					}
				});
				btnAddSigView.setBounds(270, 55, 91, 23);
				panel.add(btnAddSigView);
			}
			{
				lbViewInfo = new JLabel("None");
				lbViewInfo.setBounds(10, 55, 250, 14);
				panel.add(lbViewInfo);
			}
		}
		{
			gbSignatureInfo = new JPanel();
			gbSignatureInfo.setBorder(new TitledBorder(null, "Signature Info", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			gbSignatureInfo.setBounds(10, 227, 371, 109);
			contentPanel.add(gbSignatureInfo);
			gbSignatureInfo.setLayout(null);
			{
				cbIncludeSigInfo = new JCheckBox("Include");
				cbIncludeSigInfo.setBounds(6, 19, 97, 23);
				gbSignatureInfo.add(cbIncludeSigInfo);
			}
			{
				JLabel lblSignatureText = new JLabel("Signature Text");
				lblSignatureText.setBounds(39, 49, 103, 14);
				gbSignatureInfo.add(lblSignatureText);
			}
			{
				tbSigText = new JTextField();
				tbSigText.setBounds(200, 46, 161, 20);
				gbSignatureInfo.add(tbSigText);
				tbSigText.setColumns(10);
			}
			{
				JLabel lblSignatureComments = new JLabel("Signature Comments");
				lblSignatureComments.setBounds(39, 74, 151, 14);
				gbSignatureInfo.add(lblSignatureComments);
			}
			{
				tbSigComments = new JTextField();
				tbSigComments.setText("Type Comments Here");
				tbSigComments.setColumns(10);
				tbSigComments.setBounds(200, 71, 161, 20);
				gbSignatureInfo.add(tbSigComments);
			}
		}
		{
			cbSignDocument = new JCheckBox("Sign document");
			cbSignDocument.setSelected(true);
			cbSignDocument.setBounds(38, 343, 118, 23);
			contentPanel.add(cbSignDocument);
		}
		{
			cbSignSignatureOrigin = new JCheckBox("Sign Signature Origin");
			cbSignSignatureOrigin.setBounds(198, 343, 155, 23);
			contentPanel.add(cbSignSignatureOrigin);
		}
		{
			cbSignCoreProperties = new JCheckBox("Sign Document Properties");
			cbSignCoreProperties.setBounds(38, 369, 205, 23);
			contentPanel.add(cbSignCoreProperties);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				btnSign = new JButton("Sign");
				btnSign.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						signClick();
					}
				});
				btnSign.setActionCommand("OK");
				buttonPane.add(btnSign);
				getRootPane().setDefaultButton(btnSign);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	void showErrorMessage(String msg){
		JOptionPane.showMessageDialog(null, msg, "Error", JOptionPane.ERROR_MESSAGE);
	}
	
	protected void signClick() {
        if (_Certificate == null)
        {
        	showErrorMessage("No certificate");
            return;
        }

        int k = cmbSignatureView.getSelectedIndex();
        try
        {
            if (_OfficeDocument.getOpenXMLDocument() != null)
            {
                if ((k > 0) && (_OfficeDocument.getOpenXMLDocument().getSignatureLine(k - 1).getSignatureHandler() != null))
                {
                	showErrorMessage("Cannot attach signature to the signature line");
                    return;
                }

                TElOfficeOpenXMLSignatureHandler OpenXMLSigHandler = new TElOfficeOpenXMLSignatureHandler();
                _OfficeDocument.addSignature(OpenXMLSigHandler, true);

                if (cbSignDocument.isSelected())
                    OpenXMLSigHandler.addDocument();
                else
                    OpenXMLSigHandler.addPart(_OfficeDocument.getOpenXMLDocument().getOfficeDocumentPart());


                if (cbSignCoreProperties.isSelected())
                    OpenXMLSigHandler.addCoreProperties();

                SetSignatureInfo(OpenXMLSigHandler.getSignatureInfoV1());
                if (k > 0)
                    _OfficeDocument.getOpenXMLDocument().getSignatureLine(k - 1).setSignatureHandler(OpenXMLSigHandler);

                OpenXMLSigHandler.sign(_Certificate);
            }
            else if (_OfficeDocument.getOpenXPSDocument() != null)
            {
                if ((k > 0) && (_OfficeDocument.getOpenXPSDocument().getSignatureDefinition(k - 1).getSignatureHandler() != null))
                {
                    showErrorMessage("Cannot attach signature to the signature definition");
                    return;
                }

                TElOfficeOpenXPSSignatureHandler OpenXPSSigHandler = new TElOfficeOpenXPSSignatureHandler();
                _OfficeDocument.addSignature(OpenXPSSigHandler, true);

                OpenXPSSigHandler.addDocument();
                if (cbSignCoreProperties.isSelected())
                    OpenXPSSigHandler.addCoreProperties();

                if (cbSignSignatureOrigin.isSelected())
                    OpenXPSSigHandler.addSignatureOrigin();

                if (k > 0)
                    _OfficeDocument.getOpenXPSDocument().getSignatureDefinition(k - 1).setSignatureHandler(OpenXPSSigHandler);

                OpenXPSSigHandler.sign(_Certificate);
            }
            else if ((_OfficeDocument.getBinaryDocument() != null) && (cmbSignatureType.getSelectedIndex() == 0))
            {
                TElOfficeBinaryCryptoAPISignatureHandler BinCryptoAPISigHandler = new TElOfficeBinaryCryptoAPISignatureHandler();
                _OfficeDocument.addSignature(BinCryptoAPISigHandler, true);

                BinCryptoAPISigHandler.setExpireTime(getAddedYearDate(100));
                BinCryptoAPISigHandler.sign(_Certificate);
            }
            else if ((_OfficeDocument.getBinaryDocument() != null) && (cmbSignatureType.getSelectedIndex() == 1))
            {
                TElOfficeBinaryXMLSignatureHandler BinXMLSigHandler = new TElOfficeBinaryXMLSignatureHandler();
                _OfficeDocument.addSignature(BinXMLSigHandler, true);

                SetSignatureInfo(BinXMLSigHandler.getSignatureInfoV1());
                BinXMLSigHandler.sign(_Certificate);
            }
            else if ((_OfficeDocument.getOpenDocument() != null) && (cmbSignatureType.getSelectedIndex() == 0))
            {
                TElOpenOfficeSignatureHandler ODFSigHandler = new TElOpenOfficeSignatureHandler();
                _OfficeDocument.addSignature(ODFSigHandler, true);

                ODFSigHandler.addDocument();
                ODFSigHandler.sign(_Certificate);
            }
            else
            {
                showErrorMessage("Failed to sign");
                return;
            }
        }
        catch (Exception ex)
        {
            showErrorMessage("Failed to sign: " + ex.getMessage());
            ex.printStackTrace();
            return;
        }

        showMessage("The document signed OK");
	}

	void showMessage(String msg) {
		JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.INFORMATION_MESSAGE);
	}	
	
	protected void addSigView() {
        if (_OfficeDocument.getOpenXPSDocument() != null)
        {
            AddSignatureDefinitionForm frmAddSignatureDefinition = new AddSignatureDefinitionForm();
            {
            	frmAddSignatureDefinition.setVisible(true);
            	frmAddSignatureDefinition.setModal(true);
                if (frmAddSignatureDefinition.isOK())
                {
                    if (frmAddSignatureDefinition.isVisibleChecked())
                        _OfficeDocument.getOpenXPSDocument().addSignatureDefinition(
                          frmAddSignatureDefinition.getIntentText(),
                          frmAddSignatureDefinition.getSignerNameText(),
                          frmAddSignatureDefinition.getSignerLocationText(),
                          getAddedYearDate(1));
                    else
                        _OfficeDocument.getOpenXPSDocument().addSignatureDefinition(
                          frmAddSignatureDefinition.getIntentText(),
                          frmAddSignatureDefinition.getSignerNameText(),
                          frmAddSignatureDefinition.getSignerLocationText(),
                          getAddedYearDate(1),
                          _OfficeDocument.getOpenXPSDocument().getFixedDocument(0).getPageContent(0).getSource(),
                          100.0, 100.0);

                    cmbSignatureType_SelectedIndexChanged(null);
                }
            }
        }
	}

	@SuppressWarnings("deprecation")
	private Date getAddedYearDate(int year) {
		Date d = new Date();
		d.setYear(new Date().getYear() + year);
		return d;
	}

	protected void cmbSignatureView_SelectedIndexChanged(ItemEvent e) {
        if ((_OfficeDocument.getDocumentFormat() == TSBOfficeDocumentFormat.dfOpenXML) ||
                ((_OfficeDocument.getDocumentFormat() == TSBOfficeDocumentFormat.dfBinary) && (cmbSignatureType.getSelectedIndex() == 1)))
             {
                 cbIncludeSigInfo.setEnabled(true);
                 tbSigText.setEnabled(true);
                 tbSigComments.setEnabled(true);
             }
             else
             {
                 cbIncludeSigInfo.setEnabled(false);
                 tbSigText.setEnabled(false);
                 tbSigComments.setEnabled(false);
             }

             if (cmbSignatureView.getSelectedIndex() <= 0)
             {
                 lbViewInfo.setText("None");
                 return;
             }

             cbIncludeSigInfo.setEnabled(false);
             cbIncludeSigInfo.setSelected(true);
             String s = "";
             if (_OfficeDocument.getOpenXMLDocument() != null)
             {
                 TElOfficeOpenXMLSignatureLine SigLine = _OfficeDocument.getOpenXMLDocument().getSignatureLine(cmbSignatureView.getSelectedIndex() - 1);
                 if (SigLine.getSuggestedSigner().length() > 0)
                     s = s + "Suggested Signer: " + SigLine.getSuggestedSigner() + "\r\n";

                 if (SigLine.getSuggestedSigner2().length() > 0)
                     s = s + "Suggested Signer2: " + SigLine.getSuggestedSigner2() + "\r\n";

                 if (SigLine.getSuggestedSignerEmail().length() > 0)
                     s = s + "Suggested Signer Email: " + SigLine.getSuggestedSignerEmail() + "\r\n";

                 if (SigLine.getSigningInstructions().length() > 0)
                     s = s + "Signing Instructions: " + SigLine.getSigningInstructions() + "\r\n";

                 if (SigLine.getAdditionalSignatureInfo().length() > 0)
                     s = s + "Additional Signature Info: " + SigLine.getAdditionalSignatureInfo() + "\r\n";
             }
             else if (_OfficeDocument.getOpenXPSDocument() != null)
             {
                 TElOfficeOpenXPSSignatureDefinition SigDef = _OfficeDocument.getOpenXPSDocument().getSignatureDefinition(cmbSignatureView.getSelectedIndex() - 1);
                 if (SigDef.getSignBy().toString().length() > 0)
                     s = s + "Sign By: " + SigDef.getSignBy().toString() + "\r\n";

                 if (SigDef.getSignerName().length() > 0)
                     s = s + "Signer Name: " + SigDef.getSignerName() + "\r\n";

                 if (SigDef.getSigningLocation().length() > 0)
                     s = s + "Signing Location: " + SigDef.getSigningLocation() + "\r\n";

                 if (SigDef.getIntent().length() > 0)
                     s = s + "Intent: " + SigDef.getIntent() + "\r\n";

                 if (SigDef.getPageURI().length() > 0)
                 {
                     s = s + "Page URI: " + SigDef.getPageURI() + "\r\n";
                 }
             }

             lbViewInfo.setText(s);		
	}

	protected void cmbSignatureType_SelectedIndexChanged(ItemEvent e) {
        cmbSignatureView.setEnabled(false);
        btnAddSigView.setEnabled(false);
        cbSignDocument.setEnabled(false);
        cbSignCoreProperties.setEnabled(false);
        cbSignSignatureOrigin.setEnabled(false);
        cbSignDocument.setSelected(true);
        cbSignCoreProperties.setSelected(false);
        cbSignSignatureOrigin.setSelected(false);

        cmbSignatureView.removeAllItems();
        cmbSignatureView.addItem("None");
        if (_OfficeDocument.getOpenXMLDocument() != null)
        {
            for (int i = 0; i < _OfficeDocument.getOpenXMLDocument().getSignatureLineCount(); i++)
                cmbSignatureView.addItem(_OfficeDocument.getOpenXMLDocument().getSignatureLine(i).getID());

            cmbSignatureView.setEnabled(true);
            gbSignatureInfo.setEnabled(true);
            cbSignDocument.setEnabled(true);
            cbSignCoreProperties.setEnabled(true);
        }
        else if (_OfficeDocument.getOpenXPSDocument() != null)
        {
            for (int i = 0; i < _OfficeDocument.getOpenXPSDocument().getSignatureDefinitionCount(); i++)
                cmbSignatureView.addItem(_OfficeDocument.getOpenXPSDocument().getSignatureDefinition(i).getSpotID());

            cmbSignatureView.setEnabled(true);
            btnAddSigView.setEnabled(true);
            cbSignCoreProperties.setEnabled(true);
            cbSignSignatureOrigin.setEnabled(true);
        }
        else if ((_OfficeDocument.getBinaryDocument() != null) && (cmbSignatureType.getSelectedIndex() == 1))
        {
            gbSignatureInfo.setEnabled(true);
        }

        cmbSignatureView.setSelectedIndex(0);
        cmbSignatureView_SelectedIndexChanged(null);		
	}

	protected void selectCertificateClick() {
        SelCertForm frmSelectCertificate = new SelCertForm();
        {
        	frmSelectCertificate.setModal(true);
        	frmSelectCertificate.setVisible(true);
            if (frmSelectCertificate.isOK())
            {
                if (_Certificate != null)
                {
                    _Certificate.Free();
                    _Certificate = null;
                }

                try
                {
                	_Certificate = frmSelectCertificate.getCert();
                	btnSign.setEnabled(true);
                } catch(Exception ex) {
                	ex.printStackTrace();
                }
            }
        }		
	}

	public void setDocument(TElOfficeDocument document) {
        _OfficeDocument = document;
        cmbSignatureType.setEnabled(false);
        cmbSignatureType.removeAllItems();
        if (_OfficeDocument.getDocumentFormat() == TSBOfficeDocumentFormat.dfBinary)
        {
            cmbSignatureType.addItem(TElOfficeBinaryCryptoAPISignatureHandler.getName(TElOfficeBinaryCryptoAPISignatureHandler.class));
            cmbSignatureType.addItem(TElOfficeBinaryXMLSignatureHandler.getName(TElOfficeBinaryXMLSignatureHandler.class));
            cmbSignatureType.setEnabled(true);
        }
        else if (_OfficeDocument.getDocumentFormat() == TSBOfficeDocumentFormat.dfOpenXML)
        {
            cmbSignatureType.addItem(TElOfficeOpenXMLSignatureHandler.getName(TElOfficeOpenXMLSignatureHandler.class));
        }
        else if (_OfficeDocument.getDocumentFormat() == TSBOfficeDocumentFormat.dfOpenXPS)
        {
            cmbSignatureType.addItem(TElOfficeOpenXPSSignatureHandler.getName(TElOfficeOpenXPSSignatureHandler.class));
        }
        else if (_OfficeDocument.getDocumentFormat() == TSBOfficeDocumentFormat.dfOpenDocument)
        {
            cmbSignatureType.addItem(TElOpenOfficeSignatureHandler.getName(TElOpenOfficeSignatureHandler.class));
        }

        cmbSignatureType.setSelectedIndex(0);
        cmbSignatureType_SelectedIndexChanged(null);
        btnSign.setEnabled(false);
	}
	
    private void SetSignatureInfo(TElOfficeXMLSignatureInfoV1 SignatureInfo)
    {
        SignatureInfo.setIncluded(cbIncludeSigInfo.isSelected());
        SignatureInfo.setSignatureText(tbSigText.getText());
        SignatureInfo.setSignatureComments(tbSigComments.getText());
    }

}
