import java.awt.*;
import java.awt.event.ActionListener;

import javax.swing.*;
import javax.swing.border.*;

public class PanelProtection extends JPanel {
	static final long serialVersionUID = -4221025758725947542L;
	JPanel contentPanel;
	JPanel titlePanel;
	
	JCheckBox encSrc;
	JComboBox<String> encAlg;
	JComboBox<String> protLevel;
	JCheckBox signSrc;
	JCheckBox treatAsText;
	JComboBox<String> hashAlg;
	JCheckBox useNewFeatures;
    JCheckBox useConv;
    JCheckBox compress;
    //JCheckBox selfExtr;
    JCheckBox useOldPack;
    JCheckBox useArm;
    
    public PanelProtection() {
     
        super();
                
		contentPanel = getContentPanel();
		contentPanel.setBorder(new EmptyBorder(new Insets(10, 10, 10, 10)));

		setLayout(new BorderLayout());

		JPanel secondaryPanel = new JPanel();
		secondaryPanel.setLayout(null);
		secondaryPanel.add(contentPanel);
		add(secondaryPanel, BorderLayout.CENTER);
		
        JLabel textLabel = new JLabel("<html>Step 3/6<br>Select protection options</html>");
        textLabel.setBackground(Color.gray);
        textLabel.setBorder(new EmptyBorder(new Insets(10, 10, 10, 10)));
        textLabel.setOpaque(true);
        
        titlePanel = new JPanel();
        titlePanel.setLayout(new BorderLayout());
        titlePanel.setBackground(Color.gray);
        titlePanel.add(textLabel, BorderLayout.CENTER);
        add(titlePanel, BorderLayout.NORTH);	
    }  
    
    private JPanel getContentPanel() {     	
		JPanel panel = new JPanel();
		panel.setBounds(0, 0, 450, 252);

		encSrc = new JCheckBox("Encrypt Source");
		encSrc.setBounds(6, 7, 158, 23);
		
		encAlg = new JComboBox<String>();
		encAlg.setModel(new DefaultComboBoxModel<String>(new String[] {"CAST5", "3DES", "AES128", "AES256"}));
		encAlg.setBounds(38, 46, 99, 22);
        protLevel = new JComboBox<String>();
        protLevel.setModel(new DefaultComboBoxModel<String>(new String[] {"Low", "Normal", "High"}));
        protLevel.setBounds(173, 46, 89, 22);
        useConv = new JCheckBox("Use conventional (passphrase) encryption");
        useConv.setBounds(38, 69, 305, 23);
        compress = new JCheckBox("Compress data before encryption");
        compress.setBounds(38, 93, 277, 23);
        signSrc = new JCheckBox("Sign source");
        signSrc.setBounds(6, 115, 108, 23);
        treatAsText = new JCheckBox("Treat input as text");
        treatAsText.setBounds(27, 141, 137, 23);
        hashAlg = new JComboBox<String>();
        hashAlg.setModel(new DefaultComboBoxModel<String>(new String[] {"MD5", "SHA1", "RIPEMD160", "SHA256", "SHA384", "SHA512"}));
        hashAlg.setBounds(174, 141, 89, 22);
        useNewFeatures = new JCheckBox("Use new features (PGP > 6.5.*)");
        useNewFeatures.setBounds(27, 178, 206, 23);
        //selfExtr = new JCheckBox("Make self-extractable file");
        useOldPack = new JCheckBox("Use old packets PGP 2.3.*, 6.5.*");
        useOldPack.setBounds(235, 178, 209, 23);
        useArm = new JCheckBox("Use armoring (text output)");
        useArm.setBounds(235, 199, 195, 23);
        panel.setLayout(null);
        
        panel.add(encSrc);
        panel.add(signSrc);
        
        JLabel label = new JLabel("Encryption algorithm:");
        label.setBounds(38, 30, 126, 14);
        panel.add(label);
        panel.add(encAlg);
        panel.add(useConv);
        panel.add(compress);

        JLabel label_1 = new JLabel("Protection level:");
        label_1.setBounds(174, 30, 108, 14);
        panel.add(label_1);
        panel.add(protLevel);
        
        panel.add(treatAsText);
        
        JLabel label_2 = new JLabel("Hash algorithm:");
        label_2.setBounds(174, 119, 90, 14);
        panel.add(label_2);
        panel.add(hashAlg);
        
        panel.add(useNewFeatures);
        //panel.add(selfExtr);

        panel.add(useOldPack);
        panel.add(useArm);
        
		return panel;
    }
    
	String getFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	public boolean isFieldsValidated() {
		return encSrc.isSelected() || signSrc.isSelected();
	}
	
	public void addFieldsListener(final ActionListener l) {
		encSrc.addActionListener(l);
		signSrc.addActionListener(l);
	}	
}