import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import SecureBlackbox.Base.SBConstants;
import SecureBlackbox.PDF.TElPDFDocument;
import javax.swing.JLabel;
import javax.swing.JTextField;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class EncryptionPropsDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbHandlerName;
	private JTextField tbHandlerDescription;
	private JLabel lEncryptionAlgorithm;
	private JLabel lMetadataStatus;
	private JButton btnDecrypt;
	private boolean isOk;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			EncryptionPropsDialog dialog = new EncryptionPropsDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public EncryptionPropsDialog() {
		setTitle("Encryption properties");
		setBounds(100, 100, 376, 328);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JLabel lTitle = new JLabel("The document is encrypted");
		lTitle.setBounds(10, 11, 238, 14);
		contentPanel.add(lTitle);
		
		JLabel lblSecurityHandlerName = new JLabel("Security handler name");
		lblSecurityHandlerName.setBounds(10, 36, 249, 14);
		contentPanel.add(lblSecurityHandlerName);
		
		tbHandlerName = new JTextField();
		tbHandlerName.setEditable(false);
		tbHandlerName.setBounds(10, 61, 238, 20);
		contentPanel.add(tbHandlerName);
		tbHandlerName.setColumns(10);
		
		JLabel lblSecurityHandlerDescription = new JLabel("Security handler description");
		lblSecurityHandlerDescription.setBounds(10, 90, 249, 14);
		contentPanel.add(lblSecurityHandlerDescription);
		
		tbHandlerDescription = new JTextField();
		tbHandlerDescription.setEditable(false);
		tbHandlerDescription.setBounds(10, 115, 352, 20);
		contentPanel.add(tbHandlerDescription);
		tbHandlerDescription.setColumns(10);
		
		lEncryptionAlgorithm = new JLabel("Encryption algorithm: NONE");
		lEncryptionAlgorithm.setBounds(10, 146, 325, 14);
		contentPanel.add(lEncryptionAlgorithm);
		
		lMetadataStatus = new JLabel("Metadata status: NOT encrypted");
		lMetadataStatus.setBounds(10, 171, 325, 14);
		contentPanel.add(lMetadataStatus);
		
		JLabel lblClickdecryptButton = new JLabel("<html><body>Click 'Decrypt' button if you want to decrypt the document or<br> 'Cancel' button otherwise.</body></html>");
		lblClickdecryptButton.setBounds(10, 196, 352, 57);
		contentPanel.add(lblClickdecryptButton);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				btnDecrypt = new JButton("Decrypt");
				btnDecrypt.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						decryptClick();
					}
				});
				btnDecrypt.setActionCommand("OK");
				buttonPane.add(btnDecrypt);
				getRootPane().setDefaultButton(btnDecrypt);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	protected void decryptClick() {
		isOk = true;
		setVisible(false);
	}

	public void Init(TElPDFDocument doc) {
		String AlgStr;
		if (doc.getEncryptionHandler() != null) 
		{
			tbHandlerName.setText(doc.getEncryptionHandler().getName());
			tbHandlerDescription.setText(doc.getEncryptionHandler().getDescription());
			if (doc.getEncryptionHandler().getStreamEncryptionAlgorithm() == SBConstants.SB_ALGORITHM_CNT_RC4) 
				AlgStr = "RC4/" + doc.getEncryptionHandler().getStreamEncryptionKeyBits() + " bits";
			else
			{
				if (doc.getEncryptionHandler().getStreamEncryptionAlgorithm() == SBConstants.SB_ALGORITHM_CNT_AES128) 
					AlgStr = "AES/128 bits";
				if (doc.getEncryptionHandler().getStreamEncryptionAlgorithm() == SBConstants.SB_ALGORITHM_CNT_AES256) 
					AlgStr = "AES/256 bits";
				else 
					AlgStr = "UNKNOWN";
			}
			lEncryptionAlgorithm.setText("Encryption algorithm: " + AlgStr);
			if (doc.getEncryptionHandler().getEncryptMetadata()) 
				lMetadataStatus.setText("Metadata status: ENCRYPTED");
			else 
				lMetadataStatus.setText("Metadata status: NOT ENCRYPTED");
			btnDecrypt.setEnabled(true);
		} 
		else 
		{
			tbHandlerName.setText("UNKNOWN");
			tbHandlerDescription.setText("UNKNOWN");
			lMetadataStatus.setText("Metadata status: UNKNOWN");
			btnDecrypt.setEnabled(false);
		}
	}

	public boolean isOK() {
		return isOk;
	}
}
