import java.util.Vector;

import javax.swing.table.AbstractTableModel;

public class PropsListModel extends AbstractTableModel {
	private static final long serialVersionUID = 2771284071470299948L;
	public static final int P_INDEX = 0;
	public static final int V_INDEX = 1;
	
	protected Vector<PropsDataRow> dataVector = new Vector<PropsDataRow>();
	
    protected String[] columnNames = {
    		"Name", 
    		"Value", 
    };
    
    public PropsListModel() {}
    
    public PropsListModel(String f, String s) {
		columnNames[0] = f;
		columnNames[1] = s;
	}

	public void addItem(String p, String v, Object tag){
    	dataVector.addElement(new PropsDataRow(p, v, tag));
    	fireTableDataChanged();
    }
    	
	public String getColumnName(int column) {
        return columnNames[column];
    }
    
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

    public Object getValueAt(int row, int col) {
        PropsDataRow record = (PropsDataRow)dataVector.get(row);
        switch (col) {
        	case P_INDEX:
        		return record.prop;
        	case V_INDEX:
	        	 return record.val;
            default:
               return new Object();
        }
    }

	public void clear() {
		dataVector.removeAllElements();
	}

	public Object getItemTag(int i) {
		return ((PropsDataRow)dataVector.get(i)).Tag;
	}
}
