

import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.JFileChooser;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.JRadioButton;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JPasswordField;

import SecureBlackbox.Base.SBConstants;
import SecureBlackbox.Base.SBStrUtils;
import SecureBlackbox.Base.TElFileStream;
import SecureBlackbox.PKI.TElCertificateRequest;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;


public class Main extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;
	private JTextField tbCountry;
	private JTextField tbLocality;
	private JTextField tbOrgUnit;
	private JTextField tbemail;
	private JTextField tbState;
	private JTextField tbOrganization;
	private JTextField tbCommonName;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private JComboBox<String> comboKeyLen;
	private JTextField tbCSRFile;
	private JTextField tbKeyFile;
	private JPasswordField tbPassw;
	private JComboBox<String> comboFormat;
	private JButton btnGenerate;
	private JRadioButton rd1;
	private JRadioButton rd2;
	private JRadioButton rd3;
	private JRadioButton rd4;
	private JRadioButton rbECDSASHA1;
	private JRadioButton rbECDSASHA256;
	private JButton btnSaveResults;
	private boolean FGenerated = false;
	private TElCertificateRequest FRequest = new TElCertificateRequest();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setResizable(false);
		setTitle("Certificate Request generation sample");
		setBounds(100, 100, 597, 630);
		getContentPane().setLayout(null);
		
		JLabel lblStepFill = new JLabel("Step 1: Fill in Certificate Request fields");
		lblStepFill.setFont(new Font("Tahoma", Font.BOLD, 14));
		lblStepFill.setBounds(10, 5, 316, 23);
		getContentPane().add(lblStepFill);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Subject properties", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 36, 572, 136);
		getContentPane().add(panel);
		panel.setLayout(null);
		
		JLabel lblCountry = new JLabel("Country");
		lblCountry.setHorizontalAlignment(SwingConstants.RIGHT);
		lblCountry.setBounds(10, 24, 93, 14);
		panel.add(lblCountry);
		
		JLabel lblLocality = new JLabel("Locality");
		lblLocality.setHorizontalAlignment(SwingConstants.RIGHT);
		lblLocality.setBounds(34, 49, 69, 14);
		panel.add(lblLocality);
		
		JLabel lblOrganiztionUnit = new JLabel("Organiztion Unit");
		lblOrganiztionUnit.setHorizontalAlignment(SwingConstants.RIGHT);
		lblOrganiztionUnit.setBounds(1, 74, 102, 14);
		panel.add(lblOrganiztionUnit);
		
		JLabel lblEmail = new JLabel("E-Mail");
		lblEmail.setHorizontalAlignment(SwingConstants.RIGHT);
		lblEmail.setBounds(57, 99, 46, 14);
		panel.add(lblEmail);
		
		JLabel lblStateOrPtovince = new JLabel("State or ptovince");
		lblStateOrPtovince.setHorizontalAlignment(SwingConstants.RIGHT);
		lblStateOrPtovince.setBounds(287, 24, 102, 14);
		panel.add(lblStateOrPtovince);
		
		JLabel lblOrganization = new JLabel("Organization");
		lblOrganization.setHorizontalAlignment(SwingConstants.RIGHT);
		lblOrganization.setBounds(294, 49, 95, 14);
		panel.add(lblOrganization);
		
		JLabel lblCommonName = new JLabel("Common Name");
		lblCommonName.setHorizontalAlignment(SwingConstants.RIGHT);
		lblCommonName.setBounds(266, 74, 123, 14);
		panel.add(lblCommonName);
		
		tbCountry = new JTextField();
		tbCountry.setBounds(113, 21, 143, 20);
		panel.add(tbCountry);
		tbCountry.setColumns(10);
		
		tbLocality = new JTextField();
		tbLocality.setColumns(10);
		tbLocality.setBounds(113, 46, 143, 20);
		panel.add(tbLocality);
		
		tbOrgUnit = new JTextField();
		tbOrgUnit.setColumns(10);
		tbOrgUnit.setBounds(113, 71, 143, 20);
		panel.add(tbOrgUnit);
		
		tbemail = new JTextField();
		tbemail.setColumns(10);
		tbemail.setBounds(113, 96, 143, 20);
		panel.add(tbemail);
		
		tbState = new JTextField();
		tbState.setColumns(10);
		tbState.setBounds(394, 21, 143, 20);
		panel.add(tbState);
		
		tbOrganization = new JTextField();
		tbOrganization.setColumns(10);
		tbOrganization.setBounds(394, 46, 143, 20);
		panel.add(tbOrganization);
		
		tbCommonName = new JTextField();
		tbCommonName.setColumns(10);
		tbCommonName.setBounds(394, 71, 143, 20);
		panel.add(tbCommonName);
		
		JLabel lblStepSetup = new JLabel("Step 2: Setup Certificate properties");
		lblStepSetup.setFont(new Font("Tahoma", Font.BOLD, 14));
		lblStepSetup.setBounds(10, 183, 316, 23);
		getContentPane().add(lblStepSetup);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBorder(new TitledBorder(null, "Select public key and hash algorithms", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.setBounds(10, 217, 354, 91);
		getContentPane().add(panel_1);
		panel_1.setLayout(null);
		
		rd1 = new JRadioButton(" md2 / RSA");
		buttonGroup.add(rd1);
		rd1.setBounds(6, 20, 109, 23);
		panel_1.add(rd1);
		
		rd2 = new JRadioButton(" md5 / RSA");
		buttonGroup.add(rd2);
		rd2.setBounds(6, 46, 109, 23);
		panel_1.add(rd2);
		
		rd3 = new JRadioButton("sha1 /");
		rd3.setSelected(true);
		buttonGroup.add(rd3);
		rd3.setBounds(115, 20, 109, 23);
		panel_1.add(rd3);
		
		rd4 = new JRadioButton("sha1 /");
		buttonGroup.add(rd4);
		rd4.setBounds(115, 46, 109, 23);
		panel_1.add(rd4);
		
		rbECDSASHA1 = new JRadioButton("ECDSA/SHA1");
		rbECDSASHA1.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				comboKeyLen.setEnabled(!(rbECDSASHA1.isSelected() | rbECDSASHA256.isSelected()));
			}
		});
		buttonGroup.add(rbECDSASHA1);
		rbECDSASHA1.setBounds(226, 20, 122, 23);
		panel_1.add(rbECDSASHA1);
		
		rbECDSASHA256 = new JRadioButton("ECDSA/SHA256");
		buttonGroup.add(rbECDSASHA256);
		rbECDSASHA256.setBounds(226, 46, 122, 23);
		panel_1.add(rbECDSASHA256);
		
		JPanel panel_2 = new JPanel();
		panel_2.setBorder(new TitledBorder(null, "Select key length", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_2.setBounds(374, 217, 207, 91);
		getContentPane().add(panel_2);
		panel_2.setLayout(null);
		
		comboKeyLen = new JComboBox<String>();
		comboKeyLen.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				UpdateGenerateButton();
			}
		});
		comboKeyLen.setModel(new DefaultComboBoxModel<String>(new String[] {"512", "768", "1024", "2048", "4096"}));
		comboKeyLen.setBounds(27, 33, 84, 20);
		panel_2.add(comboKeyLen);
		
		JLabel lblBits = new JLabel("bits");
		lblBits.setBounds(127, 36, 46, 14);
		panel_2.add(lblBits);
		
		JLabel lblStepGenerate = new JLabel("Step 3: Generate Certificate Request");
		lblStepGenerate.setFont(new Font("Tahoma", Font.BOLD, 14));
		lblStepGenerate.setBounds(10, 319, 316, 23);
		getContentPane().add(lblStepGenerate);
		
		btnGenerate = new JButton("Generate");
		btnGenerate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				generate();
			}
		});
		btnGenerate.setBounds(10, 355, 246, 23);
		getContentPane().add(btnGenerate);
		
		JLabel lblStepSave = new JLabel("Step 4: Save Certificate Request and private key");
		lblStepSave.setFont(new Font("Tahoma", Font.BOLD, 14));
		lblStepSave.setBounds(10, 389, 424, 23);
		getContentPane().add(lblStepSave);
		
		JPanel panel_3 = new JPanel();
		panel_3.setBorder(new TitledBorder(null, "Specify Certificate Request and Private Key file names", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_3.setBounds(10, 423, 571, 91);
		getContentPane().add(panel_3);
		panel_3.setLayout(null);
		
		JLabel lblCertificateRequestFile = new JLabel("Certificate request file name:");
		lblCertificateRequestFile.setBounds(10, 24, 164, 14);
		panel_3.add(lblCertificateRequestFile);
		
		tbCSRFile = new JTextField();
		tbCSRFile.setBounds(183, 21, 285, 20);
		panel_3.add(tbCSRFile);
		tbCSRFile.setColumns(10);
		
		JButton bBrowseCert = new JButton("Browse");
		bBrowseCert.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbCSRFile.setText(getSaveFileName());
				UpdateSaveResultsButton();
			}
		});
		bBrowseCert.setBounds(478, 20, 83, 23);
		panel_3.add(bBrowseCert);
		
		JLabel lblPrivateKeyFile = new JLabel("Private key file name:");
		lblPrivateKeyFile.setBounds(10, 56, 164, 14);
		panel_3.add(lblPrivateKeyFile);
		
		tbKeyFile = new JTextField();
		tbKeyFile.setColumns(10);
		tbKeyFile.setBounds(183, 53, 285, 20);
		panel_3.add(tbKeyFile);
		
		JButton bBrowsePrivKey = new JButton("Browse");
		bBrowsePrivKey.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbKeyFile.setText(getSaveFileName());
				UpdateSaveResultsButton();
			}
		});
		bBrowsePrivKey.setBounds(478, 52, 83, 23);
		panel_3.add(bBrowsePrivKey);
		
		JPanel panel_4 = new JPanel();
		panel_4.setBorder(new TitledBorder(null, "Select format of request and key files", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_4.setBounds(10, 525, 280, 69);
		getContentPane().add(panel_4);
		panel_4.setLayout(null);
		
		comboFormat = new JComboBox<String>();
		comboFormat.setModel(new DefaultComboBoxModel<String>(new String[] {"PEM-encoded (text) request and private key", "DER-encoded (binary) request and private key"}));
		comboFormat.setBounds(10, 24, 260, 22);
		panel_4.add(comboFormat);
		
		JLabel lblPasswordforPem = new JLabel("Password (for PEM private keys):");
		lblPasswordforPem.setBounds(300, 525, 238, 14);
		getContentPane().add(lblPasswordforPem);
		
		tbPassw = new JPasswordField();
		tbPassw.setBounds(300, 545, 210, 20);
		getContentPane().add(tbPassw);
		
		btnSaveResults = new JButton("Save certificate request and private key");
		btnSaveResults.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				saveClick();
			}
		});
		btnSaveResults.setBounds(300, 571, 280, 23);
		getContentPane().add(btnSaveResults);
		
		init();
	}

	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		comboFormat.setSelectedIndex(0);
		comboKeyLen.setSelectedIndex(2);
		
		addTextListeners();
	}
	
	private void generate() {
		int Algorithm;
		int Hash;
		int KeySize;

		FRequest.getSubject().setCount(7);
		FRequest.getSubject().setValue(0, SBStrUtils.strToUTF8(tbCountry.getText()));
		FRequest.getSubject().setOID(0, SBConstants.SB_CERT_OID_COUNTRY.Data);
		FRequest.getSubject().setValue(1, SBStrUtils.strToUTF8(tbState.getText()));
		FRequest.getSubject().setOID(1, SBConstants.SB_CERT_OID_STATE_OR_PROVINCE.Data);
		FRequest.getSubject().setValue(2, SBStrUtils.strToUTF8(tbLocality.getText()));
		FRequest.getSubject().setOID(2, SBConstants.SB_CERT_OID_LOCALITY.Data);
		FRequest.getSubject().setValue(3, SBStrUtils.strToUTF8(tbOrganization.getText()));
		FRequest.getSubject().setOID(3, SBConstants.SB_CERT_OID_ORGANIZATION.Data);
		FRequest.getSubject().setValue(4, SBStrUtils.strToUTF8(tbOrgUnit.getText()));
		FRequest.getSubject().setOID(4, SBConstants.SB_CERT_OID_ORGANIZATION_UNIT.Data);
		FRequest.getSubject().setValue(5, SBStrUtils.strToUTF8(tbCommonName.getText()));
		FRequest.getSubject().setOID(5, SBConstants.SB_CERT_OID_COMMON_NAME.Data);
		FRequest.getSubject().setValue(6, SBStrUtils.strToUTF8(tbemail.getText()));
		FRequest.getSubject().setOID(6, SBConstants.SB_CERT_OID_EMAIL.Data);

		Algorithm = SBConstants.SB_CERT_ALGORITHM_UNKNOWN;
		Hash = SBConstants.SB_CERT_ALGORITHM_UNKNOWN;
		KeySize = Integer.parseInt((String)comboKeyLen.getSelectedItem());

		if (rd1.isSelected())
		{
			Algorithm = SBConstants.SB_CERT_ALGORITHM_ID_RSA_ENCRYPTION;
			Hash = SBConstants.SB_CERT_ALGORITHM_MD2_RSA_ENCRYPTION;
		}
		else
		if (rd2.isSelected())
		{
			Algorithm = SBConstants.SB_CERT_ALGORITHM_ID_RSA_ENCRYPTION;
			Hash = SBConstants.SB_CERT_ALGORITHM_MD5_RSA_ENCRYPTION;
		}
		else
		if (rd3.isSelected())
		{
			Algorithm = SBConstants.SB_CERT_ALGORITHM_ID_RSA_ENCRYPTION;
			Hash = SBConstants.SB_CERT_ALGORITHM_SHA1_RSA_ENCRYPTION;
		}
		else
		if (rd4.isSelected())
		{
			Algorithm = SBConstants.SB_CERT_ALGORITHM_ID_DSA;
			Hash = SBConstants.SB_CERT_ALGORITHM_ID_DSA_SHA1;
		}
		else 
		if (rbECDSASHA1.isSelected())
		{
			Algorithm = SBConstants.SB_CERT_ALGORITHM_EC;
			Hash = SBConstants.SB_CERT_ALGORITHM_SHA1_ECDSA;
			KeySize = 160;
		}
		else 
		if (rbECDSASHA256.isSelected())
		{
			Algorithm = SBConstants.SB_CERT_ALGORITHM_EC;
			Hash = SBConstants.SB_CERT_ALGORITHM_SHA256_ECDSA;
			KeySize = 256;
		}


		FRequest.generate(Algorithm, KeySize, Hash);
		FGenerated = true;
		UpdateSaveResultsButton();		
	}
	
	private void UpdateGenerateButton()
	{
		btnGenerate.setEnabled((comboKeyLen.getSelectedIndex() >= 0) && (tbCountry.getText().length() > 0) && (tbCommonName.getText().length() > 0));
	}

	private void UpdateSaveResultsButton()
	{
		btnSaveResults.setEnabled((comboFormat.getSelectedIndex() >= 0) && (tbCSRFile.getText().length() > 0) && (tbKeyFile.getText().length() > 0) && FGenerated);
	}	

	void addTextListeners() {
		addTextDocumentLisner(tbCountry, 0);
		addTextDocumentLisner(tbCommonName, 10);
		addTextDocumentLisner(tbCSRFile, 30);
		addTextDocumentLisner(tbKeyFile, 40);
	}
	
	void addTextDocumentLisner(final JTextField txt, final int id) {
		txt.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				actionPerformed(new ActionEvent(txt, 0 + id, "changed"));
			}

			public void insertUpdate(DocumentEvent e) {
				actionPerformed(new ActionEvent(txt, 1 + id, "insert"));
			}

			public void removeUpdate(DocumentEvent e) {			
				actionPerformed(new ActionEvent(txt, 2 + id, "remove"));
			}
		});
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getID() < 20)
			UpdateGenerateButton();
		else if (e.getID() > 20)
			UpdateSaveResultsButton();
	}
	
	String getSaveFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

		return "";
	}
	
	protected void saveClick() {
		TElFileStream Stream;
		Stream = new TElFileStream(tbCSRFile.getText(), "rw", true);
		if (comboFormat.getSelectedIndex() == 0)
			FRequest.saveToStreamPEM(Stream);
		else
			FRequest.saveToStream(Stream);
		Stream.Free();

		Stream = new TElFileStream(tbKeyFile.getText(), "rw", true);
		if (comboFormat.getSelectedIndex() == 0)
			FRequest.saveKeyToStreamPEM(Stream, new String(tbPassw.getPassword()));
		else
			FRequest.saveKeyToStream(Stream);
		Stream.Free();
	}	
}
