

import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.PKI.*;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


public class Main extends JDialog implements ActionListener {
	private static final long serialVersionUID = -8938687539889635131L;
	private final JPanel contentPanel = new JPanel();
	private JTextField eUser;
	private JTextField eKey;
	private JSpinner ePassLen;
    private JSpinner eCounter;
    private JTextField ePassword;
    private JTextField eCount;
    private JTextField eUserV;
    private JTextField ePasswordV;
    private JSpinner eDeltaV;
    JLabel lRes;
	JButton bGenerate;
    JButton bAdd;
    JButton bClear;
    JButton bValid;

    TElOTPUserStorage Storage;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			Main dialog = new Main();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			showErrorMessage(e.getMessage());
		}
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
        Storage = new TElOTPUserStorage();

		setTitle("Demo HOTP");
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width - 645) / 2, (screenSize.height - 440) / 2, 645, 440);

		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JPanel panelTop = new JPanel();
        panelTop.setBorder(new TitledBorder(null, "Parameters for generate password/User  ", TitledBorder.LEADING, TitledBorder.TOP, null, null));
        panelTop.setBounds(10, 10, 610, 165);
		contentPanel.add(panelTop);
        panelTop.setLayout(null);
		
		JLabel lblNewLabel = new JLabel("User ID:");
		lblNewLabel.setBounds(211, 33, 50, 15);
        panelTop.add(lblNewLabel);
		{
			eUser = new JTextField();
            eUser.setBounds(277, 30, 123, 21);
            panelTop.add(eUser);
		}

		JLabel lblNewLabel_1 = new JLabel("Key:");
		lblNewLabel_1.setBounds(234, 68, 30, 15);
        panelTop.add(lblNewLabel_1);
		{
			eKey = new JTextField();
            eKey.setBounds(277, 65, 202, 21);
            panelTop.add(eKey);
		}

        JLabel lblNewLabel_2 = new JLabel("Password length:");
        lblNewLabel_2.setBounds(154, 103, 101, 15);
        panelTop.add(lblNewLabel_2);
        {
            SpinnerModel modelLen = new SpinnerNumberModel(0, 0, 10, 1);
            ePassLen = new JSpinner(modelLen);
            ePassLen.setBounds(277, 100, 60, 21);
            panelTop.add(ePassLen);
        }

        JLabel lblNewLabel_3 = new JLabel("Counter:");
        lblNewLabel_3.setBounds(208, 138, 53, 15);
        panelTop.add(lblNewLabel_3);
        {
            SpinnerModel modelC = new SpinnerNumberModel(0, 0, 99999, 1);
            eCounter = new JSpinner(modelC);
            eCounter.setBounds(277, 135, 110, 21);
            panelTop.add(eCounter);
        }

        bGenerate = new JButton("Generate password");
        bGenerate.setBounds(10, 183, 160, 25);
        bGenerate.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                if (eKey.getText().length() == 0)
                    showErrorMessage("Empty Key");
                else if (ePassLen.getValue().toString().length() == 0)
                    showErrorMessage("Empty Password length");
                else if (eCounter.getValue().toString().length() == 0)
                    showErrorMessage("Empty counter");
                else
                    doGenerate();
            }
        });
        contentPanel.add(bGenerate);

        bGenerate = new JButton("Add user to Storage");
        bGenerate.setBounds(340, 183, 150, 25);
        bGenerate.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                if (eUser.getText().length() == 0)
                    showErrorMessage("Empty User ID");
                else if (eKey.getText().length() == 0)
                    showErrorMessage("Empty Key");
                else if (ePassLen.getValue().toString().length() == 0)
                    showErrorMessage("Empty Password length");
                else if (eCounter.getValue().toString().length() == 0)
                    showErrorMessage("Empty counter");
                else
                    doAdd();
            }
        });
        contentPanel.add(bGenerate);

        bGenerate = new JButton("Clear Storage");
        bGenerate.setBounds(503, 183, 115, 25);
        bGenerate.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                Storage.clear();
                eCount.setText(Integer.toString(Storage.getCount()));
            }
        });
        contentPanel.add(bGenerate);

        JLabel lblNewLabel_4 = new JLabel("Generated password:");
        lblNewLabel_4.setBounds(10, 221, 124, 15);
        contentPanel.add(lblNewLabel_4);
        {
            ePassword = new JTextField();
            ePassword.setBounds(157, 218, 141, 21);
            ePassword.setEditable(false);
            contentPanel.add(ePassword);
        }

        JLabel lblNewLabel_5 = new JLabel("Users in Storage:");
        lblNewLabel_5.setBounds(442, 221, 105, 15);
        contentPanel.add(lblNewLabel_5);
        {
            eCount = new JTextField();
            eCount.setBounds(565, 218, 52, 21);
            eCount.setText("0");
            eCount.setEditable(false);
            contentPanel.add(eCount);
        }

        JPanel panelBottom = new JPanel();
        panelBottom.setBorder(new TitledBorder(null, "Password check  ", TitledBorder.LEADING, TitledBorder.TOP, null, null));
        panelBottom.setBounds(10, 250, 610, 145);
        contentPanel.add(panelBottom);
        panelBottom.setLayout(null);

        JLabel lblNewLabel_6 = new JLabel("User ID:");
        lblNewLabel_6.setBounds(67, 35, 51, 15);
        panelBottom.add(lblNewLabel_6);
        {
            eUserV = new JTextField();
            eUserV.setBounds(133, 32, 123, 21);
            panelBottom.add(eUserV);
        }

        JLabel lblNewLabel_7 = new JLabel("Password:");
        lblNewLabel_7.setBounds(53, 70, 64, 15);
        panelBottom.add(lblNewLabel_7);
        {
            ePasswordV = new JTextField();
            ePasswordV.setBounds(133, 67, 155, 21);
            panelBottom.add(ePasswordV);
        }

        JLabel lblNewLabel_8 = new JLabel("Delta:");
        lblNewLabel_8.setBounds(81, 105, 39, 15);
        panelBottom.add(lblNewLabel_8);
        {
            SpinnerModel modelC = new SpinnerNumberModel(0, 0, 20, 1);
            eDeltaV = new JSpinner(modelC);
            eDeltaV.setBounds(133, 103, 60, 21);
            panelBottom.add(eDeltaV);
        }

        bValid = new JButton("Is password valid");
        bValid.setBounds(444, 30, 150, 25);
        bValid.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                if (eUserV.getText().length() == 0)
                    showErrorMessage("Empty User ID");
                else if (ePasswordV.getText().length() == 0)
                    showErrorMessage("Empty password");
                else
                    doValid();
            }
        });
        panelBottom.add(bValid);

        lRes = new JLabel("");
        lRes.setBounds(444, 72, 150, 31);
        lRes.setHorizontalAlignment(SwingConstants.CENTER);
        lRes.setFont(new Font("Serif", Font.PLAIN, 24));
        panelBottom.add(lRes);
	}

    protected void doGenerate()
    {
        byte[] KeySecret = SBUtils.bytesOfString(eKey.getText());
        int PasswordLen = (Integer)ePassLen.getValue();

        TElHOTPClient HOTPClient = new TElHOTPClient(KeySecret, PasswordLen);

        try
        {
            try
            {
                ePassword.setText(HOTPClient.getPassword((Integer)eCounter.getValue()));
            }
            catch (Exception e)
            {
                showErrorMessage(e.getMessage());
            }
        }
        finally
        {
            HOTPClient.Free();
        }
    }

    protected void doAdd()
    {
        TElHOTPUser User = new TElHOTPUser();
        try
        {
            User.setUserID(eUser.getText());
            User.setKeySecret(SBUtils.bytesOfString(eKey.getText()));
            User.setPasswordLen((Integer)ePassLen.getValue());
            User.setCounter((Integer)eCounter.getValue());

            Storage.add(User);
            eCount.setText(Integer.toString(Storage.getCount()));
        }
        finally
        {
            User.Free();
        }
    }

    protected void doValid()
    {
        TElHOTPServer HOTPServer = new TElHOTPServer(Storage);
        try
        {
            if ((Integer)eDeltaV.getValue() != 0)
            {
                HOTPServer.setDelta((Integer)eDeltaV.getValue());
            }

            try
            {
                if (HOTPServer.isPasswordValid(eUserV.getText(), ePasswordV.getText()))
                {
                    lRes.setText("Valid");
                    lRes.setForeground(Color.GREEN);
                }
                else
                {
                    lRes.setText("Not Valid");
                    lRes.setForeground(Color.RED);
                }
            }
            catch (Exception e)
            {
                lRes.setText("Error");
                lRes.setForeground(Color.RED);
                showErrorMessage(e.getMessage());
            }
        }
        finally
        {
            HOTPServer.Free();
        }
    }

    static void showErrorMessage(String msg){
        JOptionPane.showMessageDialog(null, msg, "Error", JOptionPane.ERROR_MESSAGE);
    }

    static void showMessage(String caption, String msg) {
        JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.INFORMATION_MESSAGE);
    }

    public void actionPerformed(ActionEvent e) {

    }


}
