import java.util.Vector;

import javax.swing.table.AbstractTableModel;

import SecureBlackbox.SFTPCommon.*;

public class FilesTableModel extends AbstractTableModel {

	private static final long serialVersionUID = 1L;
	public static final int NAME_INDEX = 0;
	public static final int SIZE_INDEX = 1;
	public static final int PERM_INDEX = 2;
	
	protected String columnNames[] = { "Name", "Size", "Permissions"};
	protected Vector<FilesDataRow> dataVector = new Vector<FilesDataRow>();
	
 	public String getColumnName(int column) {
        return columnNames[column];
    }
	
	public void addRow(TElSftpFileInfo info) {
		dataVector.add(new FilesDataRow(info));
		fireTableRowsInserted(dataVector.size(), dataVector.size());
	}

	public void clear() {
		dataVector.clear();
		fireTableStructureChanged();
	}

	public TElSftpFileInfo getSelectedRowTag(int row) {
		return dataVector.get(row).Tag;
	}

	public void changeRow(TElSftpFileInfo info, int row) {
		dataVector.remove(row);
		addRow(info);
	}

	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

	public Object getValueAt(int row, int col) {
		FilesDataRow record = dataVector.get(row);
		switch(col){
			case NAME_INDEX:
				return record.Name;
			case SIZE_INDEX:
				return record.Size;
			case PERM_INDEX:
				return record.Permissions;
		}
		return new Object();
	}	
}
