import java.util.Vector;
import SecureBlackbox.Base.*;
import javax.swing.table.AbstractTableModel;

public class UserTableModel extends AbstractTableModel {

    
	private static final long serialVersionUID = 1L;
    protected String[] columnNames = {"Username" };
    protected Vector<UserDataRow> dataVector = new Vector<UserDataRow>();
    
 
 	public String getColumnName(int column) {
        return columnNames[column];
    }
 	
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
        return dataVector.size();
	}

	public Object getValueAt(int row, int col) {
        UserDataRow record = (UserDataRow)dataVector.get(row);
        return record.Name;
	}

    public void setValueAt(String value, int row, int column) {
    	 UserDataRow record = (UserDataRow)dataVector.get(row);
        record.Name = value;
        fireTableCellUpdated(row, column);
    } 	
    
 	public void addRow(TElCustomUser user){
		dataVector.add(new UserDataRow(user.getName())); 			
		fireTableDataChanged();
 	}

	public String getUserName(int selectedRow) {
		return dataVector.get(selectedRow).Name;
	}

	public void clear() {
		dataVector.clear();
	}
}
