

import java.awt.BorderLayout;
import java.awt.Color;
import java.lang.Thread;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import javax.swing.JTextArea;
import javax.swing.JLabel;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.SSLCommon.*;
import SecureBlackbox.SSLServer.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.IOException;


public class Main extends JDialog {
	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbPort;
	private JTextField tbLine;
	private TElSSLServer secureServer = null;
	private TElMemoryCertStorage FMemoryCertStorage;
	private JButton btnListen;
	private JButton btnClose;
	private JButton btnSelect;
	private JLabel lblStatus;
	TElSocket serverSocket;
	private JButton btnSend;
	private JTextArea textArea;
	boolean isTerminated;
	private TElSocket clientSocket;	
	
	SelectCertDialog SelectCertForm = new SelectCertDialog();
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			Main dialog = new Main();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("SSL Chat Server");
		setBounds(100, 100, 450, 367);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Hang on port", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 422, 58);
		contentPanel.add(panel);
		panel.setLayout(null);
		
		tbPort = new JTextField();
		tbPort.setText("4567");
		tbPort.setBounds(10, 27, 86, 20);
		panel.add(tbPort);
		tbPort.setColumns(10);
		
		btnClose = new JButton("Close");
		btnClose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				closeClick();
			}
		});
		btnClose.setBounds(321, 26, 91, 23);
		panel.add(btnClose);
		
		btnListen = new JButton("Listen");
		btnListen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				listenClick();
			}
		});
		btnListen.setBounds(220, 26, 91, 23);
		panel.add(btnListen);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.setBounds(10, 80, 422, 46);
		contentPanel.add(panel_1);
		panel_1.setLayout(null);
		
		JCheckBox chckbxUseClientAuthentication = new JCheckBox("Use client authentication");
		chckbxUseClientAuthentication.setBounds(6, 7, 223, 23);
		panel_1.add(chckbxUseClientAuthentication);
		
		btnSelect = new JButton("Select Certificates");
		btnSelect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				selectCert();
			}
		});
		btnSelect.setBounds(235, 7, 162, 23);
		panel_1.add(btnSelect);
		
		textArea = new JTextArea();
		textArea.setBorder(new LineBorder(new Color(0, 0, 0)));
		textArea.setBounds(10, 137, 422, 130);
		contentPanel.add(textArea);
		
		tbLine = new JTextField();
		tbLine.setBounds(10, 278, 315, 20);
		contentPanel.add(tbLine);
		tbLine.setColumns(10);
		
		btnSend = new JButton("Send");
		btnSend.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				sendClick();
			}
		});
		btnSend.setBounds(341, 277, 91, 23);
		contentPanel.add(btnSend);
		
		lblStatus = new JLabel("Started");
		lblStatus.setBounds(10, 309, 422, 20);
		contentPanel.add(lblStatus);
		
		init();
	}

	protected void sendClick() {
		secureServer.sendData(tbLine.getText().getBytes());
		StringBuilder sb = new StringBuilder(textArea.getText());
		sb.append("[SERVER] ");
		sb.append(tbLine.getText());
		sb.append("\r\n");
		textArea.setText(sb.toString());
		tbLine.setText("");		
	}

	protected void selectCert() {
		SelectCertForm.setMode(TSelectCertMode.ServerCert);
		SelectCertForm.setStorage(FMemoryCertStorage);
		SelectCertForm.setModal(true);
		SelectCertForm.setVisible(true);
		
		if (SelectCertForm.isOk())
			FMemoryCertStorage = SelectCertForm.getStorage(FMemoryCertStorage);
	}

	private void init() {	
		//#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		//SBUtils.setLicenseKey("<put the key here>");

		secureServer = new TElSSLServer();
		secureServer.setClientAuthentication(false);
		secureServer.setEnabled(true);
		secureServer.setForceCertificateChain(false);
		
		secureServer.setVersions((short) (SBSSLConstants.sbTLS1 | SBSSLConstants.sbTLS11 | SBSSLConstants.sbTLS12));
		secureServer.setOnOpenConnection(new TSBOpenConnectionEvent(ElSecureServerOpenConnection));
        secureServer.setOnCloseConnection(new SecureBlackbox.SSLCommon.TSBCloseConnectionEvent(ElSecureServerCloseConnection));
        secureServer.setOnData(new TSBDataEvent(ElSecureServerOnData));
        secureServer.setOnSend(new TSBSendEvent(ElSecureServerSend));
        secureServer.setOnReceive(new TSBReceiveEvent(ElSecureServerReceive));
        secureServer.setOnCertificateValidate(new TSBCertificateValidateEvent(ElSecureServerCertificateValidate));
		secureServer.setOnError(new TSBErrorEvent(OnError));

		FMemoryCertStorage = new TElMemoryCertStorage();

		// Load default certificate
		try {
			SelectCertForm.loadStorage(getCurrentPath() + "/src/CertStorageDef.ucs", FMemoryCertStorage);
		} catch (Exception e) {
			showErrorMessage(e);
		}
	}
		
	private String getCurrentPath() {
		try {
			return new java.io.File(".").getCanonicalPath();
		} catch (IOException e) {
			showErrorMessage(e);
		}
		return ".";
	}
	
	protected void showErrorMessage(Exception e) {
		JOptionPane.showMessageDialog(null, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
	}

	protected void listenClick() {
		reset();
		secureServer.setCertStorage(FMemoryCertStorage);

		try 
		{
			serverSocket = new TElSocket();

		  	serverSocket.setListenPort(Integer.parseInt(tbPort.getText()));
	  	
		  	if (serverSocket.bind() == 0) {
		  		if (serverSocket.listen() == 0) {
		  			setStatusText("Listening started"); 
		  			btnListen.setEnabled(false);
		  			btnClose.setEnabled(true);
		  			tbPort.setEnabled(false);
		  			
		  			accept();
		  		
		  		} else {
		  			setStatusText("Failed to bind socket to the port");
		  		}
		  	}
		  	else {
		  		setStatusText("Failed to bind socket to the port");
		  	}
		} 
		catch(Exception ex)
		{
			ex.printStackTrace();
			reset();
			setStatusText("Start listenining failed");
			appendToMemo("Start listenining failed - " + ex.getMessage());			
		}
		
	}

	void accept() {
		isTerminated = false;
		
		java.lang.Thread t = new java.lang.Thread(new Runnable() {
			public void run() {
				try {
					processAccept();
				} catch (InterruptedException e) {
					showErrorMessage(e);
				}
			}
		});
		
		t.start();
	}
	
	void endAccept()
	{
		isTerminated = true;
	}
	
	private void processAccept() throws InterruptedException {
		synchronized (this) {
			try
			{
				while (!isTerminated) {
					TSBObject obj = new TSBObject();
					serverSocket.accept(1, obj);
	
					clientSocket = (TElSocket)obj.value;
					
					if (clientSocket == null)
					{
						Thread.sleep(1000);
						continue;
					}
					
					break;
				}
	
				endAccept();
				
				log("Client accepted. Host: " + 
						clientSocket.getRemoteAddress() + " port: " +
						clientSocket.getBoundPort());
	
				
				secureServer.open();
				
				processRequest();
				
				accept();
	
				
			} catch(Exception e) {
				setStatusText(e.getMessage());
			}
		}
	}

	private void processRequest() throws InterruptedException {	
		try
		{
			while (clientSocket.getState() == SBSocket.issConnected) 
			{
				if (clientSocket.canReceive(500) == true)
					secureServer.dataAvailable();
				else {
					Thread.sleep(50);
				}
			}
			secureServer.close(false);
			clientSocket.close(false);
		} 
		catch(Exception e)
		{
			reset();
			setStatusText("Connection closed");
			if (e instanceof NullPointerException)
				appendToMemo("Connection closed");
			else
				appendToMemo("Connection closed - " + e.getMessage());
		}	
	}

	private void log(String s) {
		setStatusText(s);
	}

	private void appendToMemo(String s) {
		StringBuilder sb = new StringBuilder(textArea.getText());
		sb.append(s);
		sb.append("\r\n");
		textArea.setText(sb.toString());
	}

	private void setStatusText(String s) {
		lblStatus.setText(s);
	}

	private void reset() {
		if (clientSocket != null)
		{
			clientSocket.close(true);
			clientSocket = null;
		}

		btnSend.setEnabled(false);
		setStatusText("");
	}
	
	protected void closeClick() {
		if (secureServer.getActive())
			secureServer.close(false);

		reset();
		
		if (serverSocket != null)
		{
			serverSocket.close(true);
			serverSocket = null;
		}

		btnListen.setEnabled(true);
		btnClose.setEnabled(false);
		tbPort.setEnabled(true);
		
		isTerminated = true;
	}
	
	// event's
	
	TSBOpenConnectionEvent.Callback ElSecureServerOpenConnection = new TSBOpenConnectionEvent.Callback() {
		public void tsbOpenConnectionEventCallback(TObject sender) {
			btnSend.setEnabled(true);

			StringBuilder sb = new StringBuilder(textArea.getText());
			sb.append("Client accepted. SSL version is ");
			if ((secureServer.getCurrentVersion() & SBSSLConstants.sbSSL2) > 0)
                sb.append("SSL2");
			else if ((secureServer.getCurrentVersion() & SBSSLConstants.sbSSL3) > 0)
				sb.append("SSL3");
			else if ((secureServer.getCurrentVersion() & SBSSLConstants.sbTLS1) > 0)
				sb.append("TLS1");
			else if ((secureServer.getCurrentVersion() & SBSSLConstants.sbTLS11) > 0)
				sb.append("TLS1.1");
			else if ((secureServer.getCurrentVersion() & SBSSLConstants.sbTLS12) > 0)
				sb.append("TLS1.2");
			sb.append("\r\n");
			
			textArea.setText(sb.toString());
		}
	};
	
	SecureBlackbox.SSLCommon.TSBCloseConnectionEvent.Callback ElSecureServerCloseConnection = new SecureBlackbox.SSLCommon.TSBCloseConnectionEvent.Callback() {

		@Override
		public void tsbCloseConnectionEventCallback(TObject arg0, TSBCloseReason arg1) {
			reset();
			setStatusText("Connection closed");
		}
	};
	
	TSBDataEvent.Callback ElSecureServerOnData = new TSBDataEvent.Callback() {
		public void tsbDataEventCallback(TObject sender, byte[] buffer) {
			StringBuilder sb = new StringBuilder(textArea.getText());
			sb.append("[CLIENT] ");
			sb.append(new String(buffer));
			sb.append("\r\n");
			textArea.setText(sb.toString());
		}
	};
	
	TSBSendEvent.Callback ElSecureServerSend = new TSBSendEvent.Callback() {
		public void tsbSendEventCallback(TObject sender, byte[] buffer) {
			try
			{
				if (clientSocket != null) 
				{
					if (buffer.length > 0) {
						TSBInteger sent = new TSBInteger();
						clientSocket.send(buffer, 0, buffer.length, sent);
					}
				}
			}
			catch(Exception ex)
			{
				reset();
				setStatusText("Connection closed");
				appendToMemo("Connection closed - " + ex.getMessage());
			}
		}
	};
	
	TSBReceiveEvent.Callback ElSecureServerReceive = new TSBReceiveEvent.Callback() {
		public void tsbReceiveEventCallback(TObject sender, byte[] buffer, int maxSize, TSBInteger written) {
			try
			{
				int err = clientSocket.receive(buffer, maxSize, written);
				if (err != 0)
					written.value = 0;
			}
			catch (Exception ex)
			{
				written.value = 0;
			}
		}
	};
	
	TSBCertificateValidateEvent.Callback ElSecureServerCertificateValidate = new TSBCertificateValidateEvent.Callback() {
		public void tsbCertificateValidateEventCallback(TObject sender, TElX509Certificate cert, TSBBoolean accept) {
			// NEVER do this in real life since this makes security void. 
			// Instead validate the certificate as described on http://www.eldos.com/sbb/articles/1966.php
			accept.value = true;
		}
	};
	
	TSBErrorEvent.Callback OnError = new TSBErrorEvent.Callback() {
		public void tsbErrorEventCallback(TObject sender, int errorCode, boolean fatal,	boolean remote) {
			StringBuilder sb = new StringBuilder(textArea.getText());
			sb.append("SSL protocol error " + errorCode);
			sb.append("\r\n");
			textArea.setText(sb.toString());
		}
	};
}
