import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;

import SecureBlackbox.XMLSecurity.TElXMLSOAPBaseSignatureHandler;
import SecureBlackbox.XMLSecurity.TElXMLSOAPMessage;
import SecureBlackbox.XMLSecurity.TElXMLSOAPSignatureHandler;
import SecureBlackbox.XMLSecurity.TElXMLWSSSignatureHandler;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class SignatureHandlerOptionsFrm extends JDialog {

	private final JPanel contentPanel = new JPanel();
	private JComboBox<String> cmbSignatureHandler, cmbSecurityHeader;
	
	private boolean isOk;

	/**
	 * Create the dialog.
	 */
	public SignatureHandlerOptionsFrm() {
		setTitle("Signature Handler Options");
		setBounds(100, 100, 360, 144);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblNewLabel = new JLabel("Signature Handler:");
			lblNewLabel.setBounds(10, 11, 102, 14);
			contentPanel.add(lblNewLabel);
		}
		
		cmbSignatureHandler = new JComboBox<String>();
		cmbSignatureHandler.setModel(new DefaultComboBoxModel<String>(new String[] {"SOAP Signature Handler", "WSS Signature Handler", "XML-DSIG Signature Handler"}));
		cmbSignatureHandler.setBounds(122, 8, 212, 20);
		cmbSignatureHandler.addActionListener (new ActionListener () {
		    public void actionPerformed(ActionEvent e) {
		    	updateOptions();
		    }
		});
		contentPanel.add(cmbSignatureHandler);
		
		JLabel lblNewLabel_1 = new JLabel("Security Header:");
		lblNewLabel_1.setBounds(10, 42, 102, 14);
		contentPanel.add(lblNewLabel_1);
		
		cmbSecurityHeader = new JComboBox<String>();
		cmbSecurityHeader.setBounds(122, 39, 212, 20);
		contentPanel.add(cmbSecurityHeader);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = false;
						setVisible(false);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		 updateOptions();
	}
	
	public void init(TElXMLSOAPMessage msg) {
		for (int i = 0; i < msg.getSecurityHeaderCount(); i++)
			cmbSecurityHeader.addItem("Security Header #" + (i + 1));
	}
	
	public void updateOptions() {
		cmbSecurityHeader.setEnabled(cmbSignatureHandler.getSelectedIndex() == 1);
	}
	
	public TElXMLSOAPBaseSignatureHandler addHandler(TElXMLSOAPMessage msg) {
		if (cmbSignatureHandler.getSelectedIndex() == 0)
			return new TElXMLSOAPSignatureHandler();
		else if (cmbSignatureHandler.getSelectedIndex() == 1)
			return new TElXMLWSSSignatureHandler();
		else if (cmbSignatureHandler.getSelectedIndex() == 2)
			return new TElXMLSOAPBaseSignatureHandler();
		else 
			return null;
	}
	
	public int getSecurityHeaderIndex() {
		return cmbSecurityHeader.getSelectedIndex();
	}
	
	public boolean isOK() {
		return isOk;
	}
}
