import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import SecureBlackbox.XML.TElXMLDOMDocument;
import SecureBlackbox.XMLSecurity.TElXMLReference;
import SecureBlackbox.XMLSecurity.TElXMLReferenceList;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class RefsDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTable table;
	private TElXMLReferenceList FReferences = null;
	private boolean FVerify = false;
	private JButton btnAdd;
	private JButton btnDelete;
	private JButton btnInfo;
	public RefDialog frmReference;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			RefsDialog dialog = new RefsDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public RefsDialog() {
		frmReference = new RefDialog();
		frmReference.setLocationRelativeTo(this);
		
		setTitle("References");
		setBounds(100, 100, 450, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JScrollPane scrollPane = new JScrollPane();
			scrollPane.setBounds(10, 11, 317, 218);
			contentPanel.add(scrollPane);
			{
				table = new JTable();
				table.setFillsViewportHeight(true);
				scrollPane.setViewportView(table);
			}
		}
		{
			btnAdd = new JButton("Add");
			btnAdd.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					add();
				}
			});
			btnAdd.setBounds(341, 42, 91, 23);
			contentPanel.add(btnAdd);
		}
		{
			btnDelete = new JButton("Delete");
			btnDelete.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					delete();
				}
			});
			btnDelete.setBounds(341, 98, 91, 23);
			contentPanel.add(btnDelete);
		}
		{
			btnInfo = new JButton("Info");
			btnInfo.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					info();
				}
			});
			btnInfo.setBounds(341, 151, 91, 23);
			contentPanel.add(btnInfo);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						setVisible(false);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	protected void info() {
		if (table.getSelectedRows().length >= 0)
		{
			frmReference.setVerify(FVerify);
			frmReference.setReference(FReferences.getReference(table.getSelectedRow()));
			frmReference.setVisible(true);
			frmReference.setModal(true);
			
			//if (frmReference.isOK())
			//	TElXMLReference Ref = frmReference.getReference();
		}

		updateReferences();		
	}

	protected void delete() {
		int numRows = table.getSelectedRows().length;
		DefaultTableModel model = ((DefaultTableModel) table.getModel());
		for (int i = 0; i < numRows; i++ ) model.removeRow(table.getSelectedRow());
	}
	
	protected void add() {
		TElXMLReference Ref = new TElXMLReference();
		frmReference.setReference(Ref);
		frmReference.setVerify(FVerify);
		frmReference.setModal(true);
		frmReference.setVisible(true);
		
		if (frmReference.isOK())
		{
			FReferences.add(frmReference.getReference());
			updateReferences();
		}		
	}
	
	private void updateReferences() {
		clearTable();
		for (int i = 0; i < FReferences.getCount(); i++)
		{
			String s = FReferences.getReference(i).getID();
			if (s != "")
				s = s + " - ";

			s = s + FReferences.getReference(i).getURI();
			if (s == "")
				s = "none";

			addRow(s);
		}
	}
	
	private void clearTable() {
		((DefaultTableModel) table.getModel()).setNumRows(0);		
	}

	private void addRow(String s) {
		((DefaultTableModel)table.getModel()).addRow(new Object[] { s });
	}

	public TElXMLReferenceList getReferences(){
		return FReferences;
	}
	
	public void setReferences(TElXMLReferenceList list) {
		FReferences = list;
	}
	
	public boolean getVerify() {
		return FVerify;
	}
	
	public void setVerify(boolean val) {
		FVerify = val;
		btnAdd.setEnabled(!FVerify);
		btnDelete.setEnabled(!FVerify);		
	}

	public void setRefDocument(TElXMLDOMDocument doc) {
		frmReference.setDocument(doc);
	}
}
